;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;	Written by John Marco Panettiere for John Marco Panettiere
;	Copyright 1998, 1999, 2000 by John Marco Panettiere.
;	All rights reserved.
;
;	ebp contains the current exception mask, except we also add in a field
; that has the tick countdown 'til the next update.
;	edi contains the current index into the history queue.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

[SECTION .text USE32]

%ifdef DOS
[EXTERN g_exceptionMask]
[EXTERN g_instructionStep]
[EXTERN g_gba]
[EXTERN g_history]
[EXTERN g_front]
[EXTERN g_badAddress]			; Address that caused an exception.
[EXTERN g_clocksTilNext]		; How many clocks 'til next event.
[EXTERN g_memMask]
[EXTERN g_pendingTimerInterrupts]
[EXTERN g_readWaitStates]
[EXTERN g_writeWaitStates]
[EXTERN g_timerUpdateCode]
%define _g_exceptionMask g_exceptionMask
%define _g_instructionStep g_instructionStep
%define _g_gba g_gba
%define _g_history g_history
%define _g_front g_front
%define _g_badAddress g_badAddress
%define _g_clocksTilNext g_clocksTilNext
%define _g_memMask g_memMask
%define _g_pendingTimerInterrupts g_pendingTimerInterrupts
%define _g_readWaitStates g_readWaitStates
%define _g_writeWaitStates g_writeWaitStates
%define _g_timerUpdateCode g_timerUpdateCode
%else
[EXTERN _g_exceptionMask]
[EXTERN _g_instructionStep]
[EXTERN _g_gba]
[EXTERN _g_history]
[EXTERN _g_front]
[EXTERN _g_badAddress]			; Address that caused an exception.
[EXTERN _g_clocksTilNext]		; How many clocks 'til next event.
[EXTERN _g_memMask]
[EXTERN _g_pendingTimerInterrupts]
[EXTERN _g_readWaitStates]
[EXTERN _g_writeWaitStates]
[EXTERN _g_timerUpdateCode]
%endif

[GLOBAL _ARMEX_SetCycles]
[GLOBAL _ARMEX_SetCycles_End]
[GLOBAL _ARMEX_Nop]
[GLOBAL _ARMEX_Nop_ExceptionsRaised]
[GLOBAL _ARMEX_Nop_StoreR15]
[GLOBAL _ARMEX_Nop_End]
[GLOBAL _ARMEX_Nop_ExceptionsRaisedCopy]
[GLOBAL _ARMEX_CheckCondition]
[GLOBAL _ARMEX_CheckCondition_SpecifyNotTaken]
[GLOBAL _ARMEX_CheckCondition_CPSR]
[GLOBAL _ARMEX_CheckCondition_Condition]
[GLOBAL _ARMEX_CheckCondition_Jump]
[GLOBAL _ARMEX_CheckCondition_End]
[GLOBAL _ARMEX_ABranchWithin]
[GLOBAL _ARMEX_ABranchWithin_End]
[GLOBAL _ARMEX_ABranchWithout]
[GLOBAL _ARMEX_ABranchWithout_End]
[GLOBAL _ARMEX_Depart]
[GLOBAL _ARMEX_Depart_Exceptions]
[GLOBAL _ARMEX_Depart_End]
[GLOBAL _ARMEX_CodeBreak]
[GLOBAL _ARMEX_CodeBreak_StoreR15]
[GLOBAL _ARMEX_CodeBreak_End]
[GLOBAL _ARMEX_MemTransferNoHistory]
[GLOBAL _ARMEX_MemTransferNoHistory_Dest]
[GLOBAL _ARMEX_MemTransferNoHistory_End]
[GLOBAL _ARMEX_MemTransfer]
[GLOBAL _ARMEX_MemTransfer_Source]
[GLOBAL _ARMEX_MemTransfer_Dest]
[GLOBAL _ARMEX_MemTransfer_Copy]
[GLOBAL _ARMEX_MemTransfer_DoTransfer]
[GLOBAL _ARMEX_MemTransfer_End]
[GLOBAL _ARMEX_MemStore]
[GLOBAL _ARMEX_MemStore_Dest]
[GLOBAL _ARMEX_MemStore_DestCopy]
[GLOBAL _ARMEX_MemStore_DoTransfer]
[GLOBAL _ARMEX_MemStore_Source]
[GLOBAL _ARMEX_MemStore_End]
[GLOBAL _ARMEX_Operand2Immediate]
[GLOBAL _ARMEX_Operand2Immediate_End]
[GLOBAL _ARMEX_Operand2Register]
[GLOBAL _ARMEX_Operand2Register_End]
[GLOBAL _ARMEX_Operand2LSL]
[GLOBAL _ARMEX_Operand2LSL_End]
[GLOBAL _ARMEX_Operand2LSR]
[GLOBAL _ARMEX_Operand2LSR_End]
[GLOBAL _ARMEX_Operand2ASR]
[GLOBAL _ARMEX_Operand2ASR_End]
[GLOBAL _ARMEX_Operand2ROR]
[GLOBAL _ARMEX_Operand2ROR_End]
[GLOBAL _ARMEX_SaveCarry]
[GLOBAL _ARMEX_SaveCarry_End]
[GLOBAL _ARMEX_PreserveCarryFlag]
[GLOBAL _ARMEX_PreserveCarryFlag_End]
[GLOBAL _ARMEX_LSR0]
[GLOBAL _ARMEX_LSR0_End]
[GLOBAL _ARMEX_ASR0]
[GLOBAL _ARMEX_ASR0_End]
[GLOBAL _ARMEX_RCR]
[GLOBAL _ARMEX_RCR_End]
[GLOBAL _ARMEX_Operand2LSLRegisterCF]
[GLOBAL _ARMEX_Operand2LSLRegisterCF_GetCPSR]
[GLOBAL _ARMEX_Operand2LSLRegisterCF_SaveCarry]
[GLOBAL _ARMEX_Operand2LSLRegisterCF_BigShift]
[GLOBAL _ARMEX_Operand2LSLRegisterCF_Shift32]
[GLOBAL _ARMEX_Operand2LSLRegisterCF_Done]
[GLOBAL _ARMEX_Operand2LSLRegisterCF_End]
[GLOBAL _ARMEX_Operand2LSLRegisterNC]
[GLOBAL _ARMEX_Operand2LSLRegisterNC_SaveCarry]
[GLOBAL _ARMEX_Operand2LSLRegisterNC_End]
[GLOBAL _ARMEX_Operand2LSRRegisterCF]
[GLOBAL _ARMEX_Operand2LSRRegisterCF_GetCPSR]
[GLOBAL _ARMEX_Operand2LSRRegisterCF_SaveCarry]
[GLOBAL _ARMEX_Operand2LSRRegisterCF_BigShift]
[GLOBAL _ARMEX_Operand2LSRRegisterCF_Shift32]
[GLOBAL _ARMEX_Operand2LSRRegisterCF_Done]
[GLOBAL _ARMEX_Operand2LSRRegisterCF_End]
[GLOBAL _ARMEX_Operand2LSRRegisterNC]
[GLOBAL _ARMEX_Operand2LSRRegisterNC_SaveCarry]
[GLOBAL _ARMEX_Operand2LSRRegisterNC_End]
[GLOBAL _ARMEX_Operand2ASRRegisterCF]
[GLOBAL _ARMEX_Operand2ASRRegisterCF_GetCPSR]
[GLOBAL _ARMEX_Operand2ASRRegisterCF_SaveCarry]
[GLOBAL _ARMEX_Operand2ASRRegisterCF_BigShift]
[GLOBAL _ARMEX_Operand2ASRRegisterCF_Done]
[GLOBAL _ARMEX_Operand2ASRRegisterCF_End]
[GLOBAL _ARMEX_Operand2ASRRegisterNC]
[GLOBAL _ARMEX_Operand2ASRRegisterNC_SaveCarry]
[GLOBAL _ARMEX_Operand2ASRRegisterNC_End]
[GLOBAL _ARMEX_Operand2RORRegisterCF]
[GLOBAL _ARMEX_Operand2RORRegisterCF_GetCPSR]
[GLOBAL _ARMEX_Operand2RORRegisterCF_SaveCarry]
[GLOBAL _ARMEX_Operand2RORRegisterCF_Done]
[GLOBAL _ARMEX_Operand2RORRegisterCF_End]
[GLOBAL _ARMEX_Operand2RORRegisterNC]
[GLOBAL _ARMEX_Operand2RORRegisterNC_SaveCarry]
[GLOBAL _ARMEX_Operand2RORRegisterNC_End]
[GLOBAL _ARMEX_RegisterLoad]
[GLOBAL _ARMEX_RegisterLoad_End]
[GLOBAL _ARMEX_ImmediateLoad]
[GLOBAL _ARMEX_ImmediateLoad_End]
[GLOBAL _ARMEX_BDP_AND]
[GLOBAL _ARMEX_BDP_AND_End]
[GLOBAL _ARMEX_BDP_EOR]
[GLOBAL _ARMEX_BDP_EOR_End]
[GLOBAL _ARMEX_BDP_SUB]
[GLOBAL _ARMEX_BDP_SUB_End]
[GLOBAL _ARMEX_BDP_RSB]
[GLOBAL _ARMEX_BDP_RSB_End]
[GLOBAL _ARMEX_BDP_ADD]
[GLOBAL _ARMEX_BDP_ADD_End]
[GLOBAL _ARMEX_BDP_ADC]
[GLOBAL _ARMEX_BDP_ADC_End]
[GLOBAL _ARMEX_BDP_SBC]
[GLOBAL _ARMEX_BDP_SBC_End]
[GLOBAL _ARMEX_BDP_RSC]
[GLOBAL _ARMEX_BDP_RSC_End]
[GLOBAL _ARMEX_BDP_ORR]
[GLOBAL _ARMEX_BDP_ORR_End]
[GLOBAL _ARMEX_BDP_BIC]
[GLOBAL _ARMEX_BDP_BIC_End]
[GLOBAL _ARMEX_BDP_MVN]
[GLOBAL _ARMEX_BDP_MVN_End]
[GLOBAL _ARMEX_BDP_MSR]
[GLOBAL _ARMEX_BDP_MSR_End]
[GLOBAL _ARMEX_BDP_StoreOp2]
[GLOBAL _ARMEX_BDP_StoreOp2_End]
[GLOBAL _ARMEX_BDP_StoreOp1]
[GLOBAL _ARMEX_BDP_StoreOp1_End]
[GLOBAL _ARMEX_SetConditionCodes]
[GLOBAL _ARMEX_SetConditionCodes_End]
[GLOBAL _ARMEX_GetCCOnOp1]
[GLOBAL _ARMEX_GetCCOnOp1_End]
[GLOBAL _ARMEX_GetCCOnOp2]
[GLOBAL _ARMEX_GetCCOnOp2_End]
[GLOBAL _ARMEX_SetLogicalConditionCodesWithCarry]
[GLOBAL _ARMEX_SetLogicalConditionCodesWithCarry_End]
[GLOBAL _ARMEX_SetLogicalConditionCodesWithoutCarry]
[GLOBAL _ARMEX_SetLogicalConditionCodesWithoutCarry_End]
[GLOBAL _ARMEX_SaveHistory]
[GLOBAL _ARMEX_SaveHistory_Copy]
[GLOBAL _ARMEX_SaveHistory_End]
[GLOBAL _ARMEX_SetupMultiply]
[GLOBAL _ARMEX_SetupMultiply_Op2]
[GLOBAL _ARMEX_SetupMultiply_NormalEnd]
[GLOBAL _ARMEX_SetupMultiply_End]
[GLOBAL _ARMEX_MultiplyUnsigned]
[GLOBAL _ARMEX_MultiplyUnsigned_End]
[GLOBAL _ARMEX_MultiplySigned]
[GLOBAL _ARMEX_MultiplySigned_End]
[GLOBAL _ARMEX_MultiplyAccumulate]
[GLOBAL _ARMEX_MultiplyAccumulate_End]
[GLOBAL _ARMEX_MultiplyDone]
[GLOBAL _ARMEX_MultiplyDone_End]
[GLOBAL _ARMEX_MultiplyUpdateFlags]
[GLOBAL _ARMEX_MultiplyUpdateFlags_GetCPSR]
[GLOBAL _ARMEX_MultiplyUpdateFlags_CPSRCopy]
[GLOBAL _ARMEX_MultiplyUpdateFlags_End]
[GLOBAL _ARMEX_ReadMemory]
[GLOBAL _ARMEX_ReadMemory_BoundsFailure]
[GLOBAL _ARMEX_ReadMemory_DummyRead]
[GLOBAL _ARMEX_ReadMemory_GetBounds]
[GLOBAL _ARMEX_ReadMemory_GetWaitStates]
[GLOBAL _ARMEX_ReadMemory_GetBitvector]
[GLOBAL _ARMEX_ReadMemory_GetBaseAddress]
[GLOBAL _ARMEX_ReadMemory_ValidSegment]
[GLOBAL _ARMEX_ReadMemory_BPType]
[GLOBAL _ARMEX_ReadMemory_End]
[GLOBAL _ARMEX_ReadByte]
[GLOBAL _ARMEX_ReadByte_End]
[GLOBAL _ARMEX_ReadWord]
[GLOBAL _ARMEX_ReadWord_End]
[GLOBAL _ARMEX_MaskLowBits]
[GLOBAL _ARMEX_MaskLowBits_End]
[GLOBAL _ARMEX_WriteByte]
[GLOBAL _ARMEX_WriteByte_End]
[GLOBAL _ARMEX_WriteWord]
[GLOBAL _ARMEX_WriteWord_End]
[GLOBAL _ARMEX_SaveEBXNoMask]
[GLOBAL _ARMEX_SaveEBXNoMask_End]
[GLOBAL _ARMEX_SaveEBXMask]
[GLOBAL _ARMEX_SaveEBXMask_End]
[GLOBAL _ARMEX_JumpTable]
[GLOBAL _ARMEX_JumpTable_Base]
[GLOBAL _ARMEX_JumpTable_End]
[GLOBAL _ARMEX_LongMultiplyDone]
[GLOBAL _ARMEX_LongMultiplyDone_RDHI]
[GLOBAL _ARMEX_LongMultiplyDone_End]
[GLOBAL _ARMEX_LongMultiplyAccDone]
[GLOBAL _ARMEX_LongMultiplyAccDone_RDHI]
[GLOBAL _ARMEX_LongMultiplyAccDone_End]
[GLOBAL _ARMEX_LongMultiplyUpdateFlags]
[GLOBAL _ARMEX_LongMultiplyUpdateFlags_GetCPSR]
[GLOBAL _ARMEX_LongMultiplyUpdateFlags_CPSRCopy]
[GLOBAL _ARMEX_LongMultiplyUpdateFlags_End]
[GLOBAL _ARMEX_MultiplyUnsigned_ZeroCTEnd]
[GLOBAL _ARMEX_MultiplyUnsigned_NormalCTEnd]
[GLOBAL _ARMEX_ReadSByte]
[GLOBAL _ARMEX_ReadSByte_End]
[GLOBAL _ARMEX_ReadHalfword]
[GLOBAL _ARMEX_ReadHalfword_End]
[GLOBAL _ARMEX_ReadSHalfword]
[GLOBAL _ARMEX_ReadSHalfword_End]
[GLOBAL _ARMEX_WriteHalfword]
[GLOBAL _ARMEX_WriteHalfword_End]
[GLOBAL _ARMEX_LongBranch]
[GLOBAL _ARMEX_LongBranch_Offset]
[GLOBAL _ARMEX_LongBranch_StoreR15]
[GLOBAL _ARMEX_LongBranch_StoreR14]
[GLOBAL _ARMEX_LongBranch_End]
[GLOBAL _ARMEX_R15Op1_Mask]
[GLOBAL _ARMEX_R15Op1_Mask_End]
[GLOBAL _ARMEX_R15Op2_Mask]
[GLOBAL _ARMEX_R15Op2_Mask_End]
[GLOBAL _ARMEX_R15Mask]
[GLOBAL _ARMEX_R15Mask_R15]
[GLOBAL _ARMEX_R15Mask_R15Copy]
[GLOBAL _ARMEX_R15Mask_End]
[GLOBAL _ARMEX_TimerHeader]
[GLOBAL _ARMEX_TimerHeader_End]
[GLOBAL _ARMEX_TimerFooter]
[GLOBAL _ARMEX_TimerFooter_End]
[GLOBAL _ARMEX_TimerCall]
[GLOBAL _ARMEX_TimerCall_End]
[GLOBAL _ARMEX_1PerCycleTimerUpdate]
[GLOBAL _ARMEX_1PerCycleTimerUpdate_Cycles]
[GLOBAL _ARMEX_1PerCycleTimerUpdate_End]
[GLOBAL _ARMEX_1PerNCycleTimerUpdate]
[GLOBAL _ARMEX_1PerNCycleTimerUpdate_LowData]
[GLOBAL _ARMEX_1PerNCycleTimerUpdate_N]
[GLOBAL _ARMEX_1PerNCycleTimerUpdate_Shift]
[GLOBAL _ARMEX_1PerNCycleTimerUpdate_LowDataCopy]
[GLOBAL _ARMEX_1PerNCycleTimerUpdate_End]
[GLOBAL _ARMEX_CascadeTimerUpdate]
[GLOBAL _ARMEX_CascadeTimerUpdate_End]
[GLOBAL _ARMEX_TimerIRQCheck]
[GLOBAL _ARMEX_TimerIRQCheck_Mask]
[GLOBAL _ARMEX_TimerIRQCheck_End]
[GLOBAL _ARMEX_TimerUpdateMultiply]
[GLOBAL _ARMEX_TimerUpdateMultiply_End]
[GLOBAL _ARMEX_JoinCycles]
[GLOBAL _ARMEX_JoinCycles_End]
[GLOBAL _ARMEX_GetBranchMemTime]
[GLOBAL _ARMEX_GetBranchMemTime_WaitStates]
[GLOBAL _ARMEX_GetBranchMemTime_End]
[GLOBAL _ExecuteOp]
[GLOBAL _IncrementTimers]

%macro CPUSH	0
	push	ebx
	push	ebp
	push	edi
	push	esi
%endmacro

%macro CPOP		0
	pop		esi
	pop		edi
	pop		ebp
	pop		ebx
%endmacro

%macro HistoryBufferFlush	0
%endmacro

%define CPSR_OVERFLOW	28
%define CPSR_CARRY		29
%define CPSR_ZER0		30
%define CPSR_SIGN		31

%define RELEASE_BUILD	0
%define LEVEL			0

%define EXC_ATOMIC				0x00000001	; For single-cycle.
%define EXC_RETIRED				0x00000002	; For single-step.
%define EXC_TIMER				0x00000004	; Timer exception (IRQ) is generated.
%define EXC_READ_BREAKPOINT		0x00000008	; Data read breakpoint condition met.
%define EXC_WRITE_BREAKPOINT	0x00000010	; Data write breakpoint condition met.
%define EXC_EXEC_BREAKPOINT		0x00000020	; Code breakpoint condition met.
%define EXC_USER_BREAKPOINT		0x00000040	; User breakpoint condition met.

%define EXC_INVALID_REG			0x00000080	; User-controlled:  invalid register.
%define EXC_BOUNDS_FAILURE		0x00000100	; User-controlled:  memory read/write out of bounds.
%define EXC_ABORT_AMBIGUOUS		0x00000200	; User-controlled:  abort processing may be ambiguous.
%define EXC_INVALID_OPCODE		0x00000400	; User-controlled:  erroneous opcode (for some reason).

%define EXC_SWI					0x00000800	; CPU:  A software interrupt is thrown.
%define EXC_UNDEFINED			0x00001000	; CPU:  An undefined instruction is thrown.

%define EXC_COPROCESSOR			0x00002000	; Internal:  a coprocessor instruction is issued.
%define EXC_STATE_CHANGE		0x00004000	; Internal:  state may change (from bx).
%define EXC_EXTERNAL_JUMP		0x00008000	; Internal:  jump outside of cache line.
%define EXC_CACHE_TERMINAL		0x00010000	; Internal:  reached end of cache line.
%define EXC_MODE_CHANGE			0x00020000	; Internal:  mode may change.

%define EXC_CYCLE_BREAK			0x80000000	; Process events (poll keys video)

%define CYCLES_I				1			; Pending experimental results.

%if (RELEASE_BUILD == 0) || (LEVEL >= 2)
	%define SAVING_HISTORY			1
%endif

%define HISTORY_BUFFER_SIZE		65536

%define CYCLE_SHIFT				20

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  A gateway to the timer update code.
_IncrementTimers:
	CPUSH

	mov		esi,eax

	shl		esi,CYCLE_SHIFT

	call	_g_timerUpdateCode

	CPOP
	ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This is a dispatcher to the current function.
_ExecuteOp:
	mov		ecx,[esp + 4]
	CPUSH

	mov		ebp,[_g_clocksTilNext]
	mov		edx,[_g_exceptionMask]

	shl		ebp,20
	mov		edi,[_g_front]

	shl		edi,2
	or		ebp,edx

	call	ecx

	; If we and eax with ebp, we get the exceptions that were actually
	; raised.
	and		eax,ebp
	shr		edi,2

	sar		ebp,20
	mov		[_g_front],edi

	mov		[_g_clocksTilNext],ebp

	CPOP

	ret

[SECTION .data USE32]
; Oh, you thought this was code?  Actually, it's data.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Load in the total number of cycles consumed by this instruction.  If we
; are doing a conditional instruction that is not taken, esi will hold the
; correct value.
;  We assume esi is shifted left by CYCLE_SHIFT.
_ARMEX_SetCycles:
	mov		esi,0x12345678
_ARMEX_SetCycles_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  We use the NOP to handle the header of all unconditional instructions.
; The jump displacement needs to be tweaked by decoders.
_ARMEX_Nop:
	mov		dword [edi + _g_history],0

	sub		ebp,esi
	mov		[edi + 4 + _g_history],esi

	add		edi,8

	and		edi,HISTORY_BUFFER_SIZE - 1

	jnz		_ARMEX_Nop_ExceptionsRaised

	HistoryBufferFlush

_ARMEX_Nop_ExceptionsRaised:
	test	ebp,0x12345678

_ARMEX_Nop_BranchDisplacement:
	jz		_ARMEX_Nop_End

_ARMEX_Nop_StoreR15:
	mov		dword [0x12345678],0x12345678

_ARMEX_Nop_ExceptionsRaisedCopy:
	mov		eax,0x12345678

	ret
_ARMEX_Nop_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This indicates that R15 has a value not known by this code stream, so we
; should exit.
_ARMEX_Depart:
	mov		dword [edi + _g_history],0

	sub		ebp,esi
	mov		[edi + 4 + _g_history],esi

	add		edi,8

	and		edi,HISTORY_BUFFER_SIZE - 1

	jnz		_ARMEX_Depart_Exceptions

	HistoryBufferFlush

_ARMEX_Depart_Exceptions:
	mov		eax,0x12345678

	ret
_ARMEX_Depart_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Use this for when a code breakpoint is encountered.
_ARMEX_CodeBreak:
	mov		eax,0x12345678
_ARMEX_CodeBreak_StoreR15:
	mov		dword [0x12345678],0x12345678

	ret
_ARMEX_CodeBreak_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Okay, here's where we do a condition test.  HEREHEREHERE I am modifying
; this to make cycle management far more sensible:  instead of hard-coding
; the cycles into every instruction, I will store the number of cycles into
; esi.  Whether a branch is taken or not, we load the correct value into esi.
_ARMEX_CheckCondition:
	sub		eax,eax
_ARMEX_CheckCondition_SpecifyNotTaken:
	mov		esi,0x12345678		; Assumed to be left-shifted by CYCLE_SHIFT.
_ARMEX_CheckCondition_CPSR:
	mov		al,[0x12345678]		; Current CPSR address here (high nybble).

_ARMEX_CheckCondition_Condition:
	cmp		byte [eax + 0x12345678],0xff	; Insert condition code.
_ARMEX_CheckCondition_Jump:
	jb		near _ARMEX_CheckCondition_End
_ARMEX_CheckCondition_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This does an absolute branch to a region outside of the cache line.  It
; is assumed that R15 is already updated.
_ARMEX_ABranchWithout:
	mov		eax,0x12345678
	ret
_ARMEX_ABranchWithout_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This does a transfer from one pre-determined memory location to another.
_ARMEX_MemTransfer:
_ARMEX_MemTransfer_Source:
	mov		eax,[0x12345678]
_ARMEX_MemTransfer_Dest:
	mov		ebx,0x12345678
_ARMEX_MemTransfer_Copy:
	mov		ecx,[0x12345678]

	mov		[edi + _g_history],ebx
	mov		[edi + 4 + _g_history],ecx
	add		edi,8

	and		edi,HISTORY_BUFFER_SIZE - 1
	jnz		_ARMEX_MemTransfer_DoTransfer

	HistoryBufferFlush

_ARMEX_MemTransfer_DoTransfer:
	mov		[ebx],eax
_ARMEX_MemTransfer_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Do a memory transfer without bothering with the history.
_ARMEX_MemTransferNoHistory:
	mov		eax,[0x12345678]
_ARMEX_MemTransferNoHistory_Dest:
	mov		[0x12345678],eax
_ARMEX_MemTransferNoHistory_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This writes an immediate value to a memory location.
_ARMEX_MemStore:
_ARMEX_MemStore_Dest:
	mov		ebx,0x12345678
_ARMEX_MemStore_DestCopy:
	mov		ecx,[0x12345678]

	mov		[edi + _g_history],ebx
	mov		[edi + 4 + _g_history],ecx
	add		edi,8

	and		edi,HISTORY_BUFFER_SIZE - 1
	jnz		_ARMEX_MemStore_DoTransfer

	HistoryBufferFlush

_ARMEX_MemStore_DoTransfer:
_ARMEX_MemStore_Source:
	mov		dword [ebx],0x12345678
_ARMEX_MemStore_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Here's where we start working on the basic data processing instructions.
; We start by looking at operand 2, which we will ultimately place in edx.
; The first case:  edx is an immediate.
_ARMEX_Operand2Immediate:
	mov		edx,0x12345678
_ARMEX_Operand2Immediate_End:

;  edx is a register that we load.
_ARMEX_Operand2Register:
	mov		edx,[0x12345678]
_ARMEX_Operand2Register_End:

;  edx gets shifted left by an immediate (non-zero).
_ARMEX_Operand2LSL:
	shl		edx,0x3
_ARMEX_Operand2LSL_End:

;  edx gets shifted right (logically) by an immediate.
_ARMEX_Operand2LSR:
	shr		edx,0x3
_ARMEX_Operand2LSR_End:

;  edx gets shifted right (arithmetically) by an immediate.
_ARMEX_Operand2ASR:
	sar		edx,0x3
_ARMEX_Operand2ASR_End:

;  edx gets rotated right by an immediate.
_ARMEX_Operand2ROR:
	ror		edx,0x3
_ARMEX_Operand2ROR_End:

;  If we're doing a logical op with the S bit set, and we're not doing LSL 0,
; we save the carry flag (in esi).
_ARMEX_SaveCarry:
	sbb		esi,esi
_ARMEX_SaveCarry_End:

; LSL by 0:  save the carry flag.
_ARMEX_PreserveCarryFlag:
	mov		esi,[0x12345678]
	shr		esi,CPSR_CARRY + 1
	sbb		esi,esi
_ARMEX_PreserveCarryFlag_End:

;  If we do lsr by 0, we set esi=bit 31(edx).
_ARMEX_LSR0:
	mov		esi,edx

	sar		esi,31
_ARMEX_LSR0_End:

;  If we do asr by 0, then we actually do asr by 31 (and copy this value into
; esi).
_ARMEX_ASR0:
	mov		esi,edx
_ARMEX_ASR0_End:

;  If we do ror by 0, then we're doing rcr by 1.
_ARMEX_RCR:
	mov		esi,[0x12345678]		; CPSR.
	shr		esi,CPSR_CARRY + 1		; Extract the carry bit.
	rcr		edx,1
_ARMEX_RCR_End:

;  LSL by the contents of a register.  This form saves the carry flag.
_ARMEX_Operand2LSLRegisterCF:
	mov		ecx,[0x12345678]
_ARMEX_Operand2LSLRegisterCF_GetCPSR:
	mov		esi,[0x12345678]

	and		ecx,0xff
	jz		_ARMEX_Operand2LSLRegisterCF_SaveCarry

	cmp		ecx,0x20
	ja		_ARMEX_Operand2LSLRegisterCF_BigShift
	jz		_ARMEX_Operand2LSLRegisterCF_Shift32	; Carry = 0.

	shl		edx,cl
	jmp		_ARMEX_Operand2LSLRegisterCF_Done
_ARMEX_Operand2LSLRegisterCF_SaveCarry:
	shr		esi,CPSR_CARRY + 1
	jmp		_ARMEX_Operand2LSLRegisterCF_Done
_ARMEX_Operand2LSLRegisterCF_BigShift:
	shr		edx,1
_ARMEX_Operand2LSLRegisterCF_Shift32:
	mov		edx,0

_ARMEX_Operand2LSLRegisterCF_Done:
	sbb		esi,esi
_ARMEX_Operand2LSLRegisterCF_End:

;  LSL by the contents of a register.  This form doesn't care about the
; carry flag.
_ARMEX_Operand2LSLRegisterNC:
	mov		ecx,[0x12345678]

	and		ecx,0xff
	jz		_ARMEX_Operand2LSLRegisterNC_SaveCarry

	cmp		ecx,0x20
	sbb		esi,esi

	shl		edx,cl
	and		edx,esi
_ARMEX_Operand2LSLRegisterNC_SaveCarry:
_ARMEX_Operand2LSLRegisterNC_End:

;  LSR by the contents of a register.  We save the carry output.
_ARMEX_Operand2LSRRegisterCF:
	mov		ecx,[0x12345678]
_ARMEX_Operand2LSRRegisterCF_GetCPSR:
	mov		esi,[0x12345678]

	and		ecx,0xff
	jz		_ARMEX_Operand2LSRRegisterCF_SaveCarry

	cmp		ecx,0x20
	ja		_ARMEX_Operand2LSRRegisterCF_BigShift
	jz		_ARMEX_Operand2LSRRegisterCF_Shift32

	shr		edx,cl
	jmp		_ARMEX_Operand2LSRRegisterCF_Done
_ARMEX_Operand2LSRRegisterCF_SaveCarry:
	shr		esi,CPSR_CARRY + 1
	jmp		_ARMEX_Operand2LSRRegisterCF_Done
_ARMEX_Operand2LSRRegisterCF_BigShift:
	add		edx,edx
_ARMEX_Operand2LSRRegisterCF_Shift32:
	mov		edx,0

_ARMEX_Operand2LSRRegisterCF_Done:
	sbb		esi,esi
_ARMEX_Operand2LSRRegisterCF_End:

;  LSR by the contents of a register.  This form doesn't care about the
; carry flag.
_ARMEX_Operand2LSRRegisterNC:
	mov		ecx,[0x12345678]

	and		ecx,0xff
	jz		_ARMEX_Operand2LSRRegisterNC_SaveCarry

	cmp		ecx,0x20
	sbb		esi,esi

	shr		edx,cl
	and		edx,esi
_ARMEX_Operand2LSRRegisterNC_SaveCarry:
_ARMEX_Operand2LSRRegisterNC_End:

;  ASR by the contents of a register.  We save the carry output.
_ARMEX_Operand2ASRRegisterCF:
	mov		ecx,[0x12345678]
_ARMEX_Operand2ASRRegisterCF_GetCPSR:
	mov		esi,[0x12345678]

	and		ecx,0xff
	jz		_ARMEX_Operand2ASRRegisterCF_SaveCarry

	cmp		ecx,0x20
	jae		_ARMEX_Operand2ASRRegisterCF_BigShift

	sar		edx,cl
	jmp		_ARMEX_Operand2ASRRegisterCF_Done
_ARMEX_Operand2ASRRegisterCF_SaveCarry:
	shr		esi,CPSR_CARRY + 1
	jmp		_ARMEX_Operand2ASRRegisterCF_Done
_ARMEX_Operand2ASRRegisterCF_BigShift:
	sar		edx,31
	cmp		ecx,edx					; We know ecx <= 255.

_ARMEX_Operand2ASRRegisterCF_Done:
	sbb		esi,esi
_ARMEX_Operand2ASRRegisterCF_End:

;  ASR by the contents of a register.  This form doesn't care about the
; carry flag.
_ARMEX_Operand2ASRRegisterNC:
	mov		ecx,[0x12345678]
	mov		esi,0x1f

	and		ecx,0xff
	jz		_ARMEX_Operand2ASRRegisterNC_SaveCarry

	cmp		ecx,0x1f

	adc		esi,0

	or		ecx,esi

	sar		edx,cl
_ARMEX_Operand2ASRRegisterNC_SaveCarry:
_ARMEX_Operand2ASRRegisterNC_End:

;  ROR by the contents of a register.  We save the carry output.
_ARMEX_Operand2RORRegisterCF:
	mov		ecx,[0x12345678]
_ARMEX_Operand2RORRegisterCF_GetCPSR:
	mov		esi,[0x12345678]

	and		ecx,0xff
	jz		_ARMEX_Operand2RORRegisterCF_SaveCarry

	ror		edx,cl
	jmp		_ARMEX_Operand2RORRegisterCF_Done
_ARMEX_Operand2RORRegisterCF_SaveCarry:
	shr		esi,CPSR_CARRY + 1
_ARMEX_Operand2RORRegisterCF_Done:
	sbb		esi,esi
_ARMEX_Operand2RORRegisterCF_End:

;  ROR by the contents of a register.  This form doesn't care about the
; carry flag.
_ARMEX_Operand2RORRegisterNC:
	mov		ecx,[0x12345678]
	ror		edx,cl
_ARMEX_Operand2RORRegisterNC_SaveCarry:
_ARMEX_Operand2RORRegisterNC_End:

;  This loads a register operand into ecx.
_ARMEX_RegisterLoad:
	mov		ecx,[0x12345678]
_ARMEX_RegisterLoad_End:

;  This loads an immediate operand into ecx.
_ARMEX_ImmediateLoad:
	mov		ecx,0x12345678
_ARMEX_ImmediateLoad_End:

; AND instruction.
_ARMEX_BDP_AND:
	and		ecx,edx
_ARMEX_BDP_AND_End:

; EOR.
_ARMEX_BDP_EOR:
	xor		ecx,edx
_ARMEX_BDP_EOR_End:

; SUB.
_ARMEX_BDP_SUB:
	sub		ecx,edx
	cmc
_ARMEX_BDP_SUB_End:

; RSB.
_ARMEX_BDP_RSB:
	sub		edx,ecx
	cmc
_ARMEX_BDP_RSB_End:

; ADD.
_ARMEX_BDP_ADD:
	add		ecx,edx
_ARMEX_BDP_ADD_End:

; ADC.  We know esi is available.
_ARMEX_BDP_ADC:
	mov		esi,[0x12345678]
	shr		esi,CPSR_CARRY + 1
	adc		ecx,edx
_ARMEX_BDP_ADC_End:

; SBC.
_ARMEX_BDP_SBC:
	mov		esi,[0x12345678]
	xor		esi,1 << CPSR_CARRY
	shr		esi,CPSR_CARRY + 1
	sbb		ecx,edx
	cmc
_ARMEX_BDP_SBC_End:

; RSC.
_ARMEX_BDP_RSC:
	mov		esi,[0x12345678]
	xor		esi,1 << CPSR_CARRY
	shr		esi,CPSR_CARRY + 1
	sbb		edx,ecx
	cmc
_ARMEX_BDP_RSC_End:

; ORR.
_ARMEX_BDP_ORR:
	or		ecx,edx
_ARMEX_BDP_ORR_End:

; BIC.
_ARMEX_BDP_BIC:
	not		edx
	and		ecx,edx
_ARMEX_BDP_BIC_End:

; MVN.
_ARMEX_BDP_MVN:
	not		edx
_ARMEX_BDP_MVN_End:

; This is the MSR where we only modify the flag bits.
_ARMEX_BDP_MSR:
	and		edx,0xf0000000
	and		ecx,0x0fffffff
	or		ecx,edx
_ARMEX_BDP_MSR_End:

; Used to mask off low bits when R15 is the target of a transfer.
_ARMEX_R15Op1_Mask:
	and		ecx,0x12345678
_ARMEX_R15Op1_Mask_End:

; Used to mask off low bits when R15 is the target of a transfer.
_ARMEX_R15Op2_Mask:
	and		edx,0x12345678
_ARMEX_R15Op2_Mask_End:

; Store operand2 to the destination (we also use this for reverse-ops).
_ARMEX_BDP_StoreOp2:
	mov		[0x12345678],edx
_ARMEX_BDP_StoreOp2_End:

; Store operand1 to the destination.
_ARMEX_BDP_StoreOp1:
	mov		[0x12345678],ecx
_ARMEX_BDP_StoreOp1_End:

; Set the condition codes.
_ARMEX_SetConditionCodes:
	mov		eax,0x12345678
	pushfd
	pop		ecx

	mov		edx,ecx
	mov		ebx,ecx

	shr		ecx,7			; Get overflow into position.
	and		edx,0xc0

	shl		ebx,5
	and		ecx,0x10

	and		ebx,0x20
	or		ecx,edx

	mov		edx,[eax]
	or		ecx,ebx

	shl		ecx,24
	and		edx,0x0fffffff

	or		ecx,edx
	mov		[eax],ecx
_ARMEX_SetConditionCodes_End:

; Set condition codes for operand 1.
_ARMEX_GetCCOnOp1:
	test	ecx,ecx
_ARMEX_GetCCOnOp1_End:

_ARMEX_GetCCOnOp2:
	test	edx,edx
_ARMEX_GetCCOnOp2_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  When dealing with the logical condition codes, we're given that N and Z
; are set based on the operand's value.  The carry flag is stored in esi as
; the result of the shift operation (except for LSL by 0).  The overflow
; flag is preserved.
_ARMEX_SetLogicalConditionCodesWithCarry:
	mov		eax,0x12345678
	pushfd
	pop		ecx

	shl		ecx,24
	and		esi,1 << CPSR_CARRY

	mov		edx,[eax]
	and		ecx,0xc0000000

	and		edx,0x1fffffff
	or		ecx,esi

	or		ecx,edx

	mov		[eax],ecx
_ARMEX_SetLogicalConditionCodesWithCarry_End:

;  Same, but carry is preserved.
_ARMEX_SetLogicalConditionCodesWithoutCarry:
	mov		eax,0x12345678
	pushfd
	pop		ecx

	shl		ecx,24
	mov		edx,[eax]

	and		ecx,0xc0000000	; Make overflow semi-random.
	and		edx,0x3fffffff	; Save carry and overflow.

	or		ecx,edx

	mov		[eax],ecx
_ARMEX_SetLogicalConditionCodesWithoutCarry_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This does a SaveHistory on the indicated operand.
_ARMEX_SaveHistory:
	mov		ebx,0x12345678
_ARMEX_SaveHistory_Copy:
	mov		ecx,[0x12345678]

	mov		[edi + _g_history],ebx
	mov		[edi + 4 + _g_history],ecx

	add		edi,8

	and		edi,HISTORY_BUFFER_SIZE - 1
	jnz		_ARMEX_SaveHistory_End

	HistoryBufferFlush

_ARMEX_SaveHistory_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This will effect the normal multiply instruction.  I'm going to try to set
; it up so that this can be used for the long-multiply form also.
_ARMEX_SetupMultiply:
	mov		eax,[0x12345678]
_ARMEX_SetupMultiply_Op2:
	mov		ecx,[0x12345678]
_ARMEX_SetupMultiply_NormalEnd:
	mov		ebx,[0x12345678]
_ARMEX_SetupMultiply_End:

;  Do an unsigned multiply.  We will also do all needed cycle-updates.  These
; are based on whether ecx's high bits are all 0 or all 1.  Well, both can't
; be true at the same time, and we exploit that fact.
_ARMEX_MultiplyUnsigned:
	sub		edx,edx
	cmp		ecx,0x100

	adc		edx,edx
	cmp		ecx,0x10000

	adc		edx,edx
	cmp		ecx,0x1000000

	adc		edx,edx
_ARMEX_MultiplyUnsigned_ZeroCTEnd:
	mov		esi,-1

; Okay, edx has a 3-bit value that tells us its most powerful 0-bit situation.
; Now, we check for 1's in high locations.
	cmp		ecx,0xfffffeff
	adc		esi,esi

	cmp		ecx,0xfffeffff
	adc		esi,esi

	cmp		ecx,0xfeffffff
	adc		esi,esi

	not		esi

	or		edx,esi
_ARMEX_MultiplyUnsigned_NormalCTEnd:
	mov		edx,[edx * 4 + s_multiplyCycleTimes]
	push	edx

	sub		ebp,edx
	mul		ecx
_ARMEX_MultiplyUnsigned_End:

;  Do a signed multiply.
_ARMEX_MultiplySigned:
	sub		edx,edx
	cmp		ecx,0x100

	adc		edx,edx
	cmp		ecx,0x10000

	adc		edx,edx
	cmp		ecx,0x1000000

	adc		edx,edx
	mov		esi,-1

	cmp		ecx,0xfffffeff
	adc		esi,esi

	cmp		ecx,0xfffeffff
	adc		esi,esi

	cmp		ecx,0xfeffffff
	adc		esi,esi

	not		esi

	or		edx,esi
	mov		edx,[edx * 4 + s_multiplyCycleTimes]

	push	edx
	sub		ebp,edx

	imul	ecx
_ARMEX_MultiplySigned_End:

;  Do the accumulation stage.
_ARMEX_MultiplyAccumulate:
	add		eax,ebx
_ARMEX_MultiplyAccumulate_End:

;  Store the result.
_ARMEX_MultiplyDone:
	mov		[0x12345678],eax
_ARMEX_MultiplyDone_End:

_ARMEX_MultiplyUpdateFlags:
	cmp		eax,1
_ARMEX_MultiplyUpdateFlags_GetCPSR:
	mov		ebx,[0x12345678]

	sbb		esi,esi
	and		eax,0x80000000		; Sign bit is highest bit!

	and		esi,0x40000000
	and		ebx,0x1fffffff

	or		ebx,eax
	or		ebx,esi

_ARMEX_MultiplyUpdateFlags_CPSRCopy:
	mov		[0x12345678],ebx
_ARMEX_MultiplyUpdateFlags_End:

;  For long-multiplies, we have to do two stores, or an accumulate followed
; by two stores.
_ARMEX_LongMultiplyDone:
	mov		[0x12345678],eax
_ARMEX_LongMultiplyDone_RDHI:
	mov		[0x12345678],edx
_ARMEX_LongMultiplyDone_End:

;  long-MYAC.
_ARMEX_LongMultiplyAccDone:
	add		[0x12345678],eax
_ARMEX_LongMultiplyAccDone_RDHI:
	adc		[0x12345678],edx
_ARMEX_LongMultiplyAccDone_End:

;  When we update flags for long multiplication, we have to examine the full
; 64-bit value.
_ARMEX_LongMultiplyUpdateFlags:
	or		eax,edx				; For zero check.
_ARMEX_LongMultiplyUpdateFlags_GetCPSR:
	mov		ebx,[0x12345678]

	and		edx,0x80000000		; Sign bit is highest bit!
	cmp		eax,1

	sbb		esi,esi
	and		ebx,0x0fffffff

	and		esi,0x40000000
	or		ebx,edx

	or		ebx,esi
_ARMEX_LongMultiplyUpdateFlags_CPSRCopy:
	mov		[0x12345678],ebx
_ARMEX_LongMultiplyUpdateFlags_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This will:
;	- Convert the GBA address specified in ecx to an x86 physical address.
;	  If there is a bounds failure, we either throw an exception or use a
;	  dummy value.
;	- The x86 address is returned in ebx.
;	- esi is 0 iff there is no data-read breakpoint, else it is set to -1.
;	- ecx remains unchanged (except on RET).
_ARMEX_ReadMemory:
	mov		eax,0x12345678
	mov		[edi + _g_history],eax

	mov		[edi + 4 + _g_history],ecx
	add		edi,8

	and		edi,HISTORY_BUFFER_SIZE - 1
	jnz		_ARMEX_StartRead

	HistoryBufferFlush

_ARMEX_StartRead:
	cmp		ecx,0x0fffffff
	mov		[_g_badAddress],ecx
	jbe		_ARMEX_ReadMemory_ValidSegment

_ARMEX_ReadMemory_BoundsFailure:
	mov		eax,EXC_BOUNDS_FAILURE

	test	ebp,eax
	jz		_ARMEX_ReadMemory_DummyRead

	ret

;  The user is willing to allow reads from an invalid memory address.  Make
; a bad dword and return.
_ARMEX_ReadMemory_DummyRead:
	mov		esi,0x800000
	push	esi
	sub		esi,esi
	mov		ebx,s_dummy
	jmp		_ARMEX_ReadMemory_End

_ARMEX_ReadMemory_ValidSegment:
	mov		esi,ecx
	mov		ebx,ecx

	shr		esi,24
	and		ebx,[esi * 4 + _g_memMask]		; Doesn't change for RWX.

_ARMEX_ReadMemory_GetBounds:
	mov		eax,[esi * 4 + 0x12345678]

_ARMEX_ReadMemory_GetWaitStates:
	push	dword [esi * 4 + 0x12345678]	; We'll use this later!

_ARMEX_ReadMemory_GetBitvector:
	mov		edx,[esi * 4 + 0x12345678]

	cmp		ebx,eax

	jb		_ARMEX_ReadMemory_BoundsOK

	pop		esi
	jmp		_ARMEX_ReadMemory_BoundsFailure

_ARMEX_ReadMemory_BoundsOK:

	mov		eax,ebx

_ARMEX_ReadMemory_GetBaseAddress:
	add		ebx,[esi * 4 + 0x12345678]

	shr		eax,2
	bt		[edx],eax

	sbb		esi,esi

_ARMEX_ReadMemory_BPType:
	and		esi,0x12345678

	or		ebp,esi
_ARMEX_ReadMemory_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Mask off the low bits, for dword reads/writes.
_ARMEX_MaskLowBits:
	and		ebx,-4
_ARMEX_MaskLowBits_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This does an unsigned byte fetch on the memory addressed by ebx.  The
; result is stored in edx.
_ARMEX_ReadByte:
	sub		edx,edx
	mov		dl,[ebx]
_ARMEX_ReadByte_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  A signed byte fetch.
_ARMEX_ReadSByte:
	movsx	edx,byte [ebx]
_ARMEX_ReadSByte_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  An unsigned halfword read from memory.
_ARMEX_ReadHalfword:
	sub		edx,edx
	mov		dx,[ebx]
_ARMEX_ReadHalfword_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  A signed halfword read from memory.
_ARMEX_ReadSHalfword:
	movsx	edx,word [ebx]
_ARMEX_ReadSHalfword_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This does a word fetch on the memory addressed by ebx, using the ARM rules
; for unaligned reads.
;  HEREHEREHERE we have to verify these rules for word reads.
_ARMEX_ReadWord:
	mov		edx,[ebx]

	push	ecx

	and		ecx,3

	shl		ecx,3

	ror		edx,cl
	pop		ecx
_ARMEX_ReadWord_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Store a byte at ebx.  HEREHEREHERE I'm hard-coding special behavior for
; segment 6.
_ARMEX_WriteByte:
	mov		eax,ecx
	shr		eax,24
	cmp		eax,6
	jnz		_ARMEX_WriteByte_Normal

	mov		eax,ebx
	mov		[ebx],dl
	xor		eax,1
	mov		[eax],dl
	jmp		_ARMEX_WriteByte_End

_ARMEX_WriteByte_Normal:
	mov		[ebx],dl
_ARMEX_WriteByte_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Store a word at ebx.
_ARMEX_WriteHalfword:
	mov		[ebx],dx
_ARMEX_WriteHalfword_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Store a dword at ebx.
_ARMEX_WriteWord:
	push	ecx
	shl		ecx,3
	ror		edx,cl
	pop		ecx
	mov		[ebx],edx
_ARMEX_WriteWord_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Save the history of the memory pointed to by ebx.  Use this when we
; already know that ebx is dword aligned.
_ARMEX_SaveEBXNoMask:
	mov		eax,[ebx]
	mov		[edi + _g_history],ebx

	mov		[edi + 4 + _g_history],eax
	add		edi,8

	and		edi,HISTORY_BUFFER_SIZE - 1
	jnz		_ARMEX_SaveEBXNoMask_End

	HistoryBufferFlush

_ARMEX_SaveEBXNoMask_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Save the history of ebx when we don't know if it's dword aligned.
_ARMEX_SaveEBXMask:
	mov		eax,ebx

	and		eax,-4

	mov		[edi + _g_history],eax
	mov		eax,[eax]

	mov		[edi + 4 + _g_history],eax
	add		edi,8

	and		edi,HISTORY_BUFFER_SIZE - 1
	jnz		_ARMEX_SaveEBXMask_End

	HistoryBufferFlush

_ARMEX_SaveEBXMask_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This will implement the jump table used by the BDT instructions.
_ARMEX_JumpTable:
	mov		eax,[0x12345678]
_ARMEX_JumpTable_Base:
	jmp		[eax + 0x12345678]
	resd	16
_ARMEX_JumpTable_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  This will implement the peculiar thumb long-branch instructions.  This is
; case 1.  We will assume that the SaveHistory instructions are already done.
_ARMEX_LongBranch:
	mov		eax,[0x12345678]		; R14.
_ARMEX_LongBranch_Offset:
	add		eax,0x12345678			; disp.
_ARMEX_LongBranch_StoreR15:
	mov		[0x12345678],eax		; R15.
_ARMEX_LongBranch_StoreR14:
	mov		dword [0x12345678],0x12345678	; R14 <- return address.
_ARMEX_LongBranch_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Mask R15, after it has been stored, based on the present state.
_ARMEX_R15Mask:
	mov		ecx,[0x12345678]		; Get CPSR.
_ARMEX_R15Mask_R15:
	mov		edx,[0x12345678]

	shr		ecx,4					; We know bit 0 is always 1, but be safe.

	and		ecx,2

	or		ecx,-4

	and		edx,ecx
_ARMEX_R15Mask_R15Copy:
	mov		[0x12345678],edx
_ARMEX_R15Mask_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  If we are doing a multiply, we insert this.
_ARMEX_TimerUpdateMultiply:
	pop		eax
	add		esi,eax
_ARMEX_TimerUpdateMultiply_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  When we have multiple items on the stack, we wish to join them.
_ARMEX_JoinCycles:
	pop		eax
	pop		edx
	add		eax,edx
	push	eax
_ARMEX_JoinCycles_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  The header of our timer handler - basically, nothing done here.
_ARMEX_TimerHeader:
_ARMEX_TimerHeader_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  The footer of our timer handler - return from function call.
_ARMEX_TimerFooter:
	ret
_ARMEX_TimerFooter_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  esi has the number of cycles consumed by this operation (left-shifted).
; We call the timer handler to update the timers appropriately.
_ARMEX_TimerCall:
	mov		edx,_g_timerUpdateCode
	call	edx
_ARMEX_TimerCall_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  Given the frequency of timer updates, I am going to be making a custom
; block of code that handles updating the timers.  We have 3 situations for
; a timer:  decrement it according to some frequency, decrement it on a
; cascade, or ignore it.  In the frequency case, we will be using some
; "internal" registers to handle the low-order portion of the update.
_ARMEX_1PerCycleTimerUpdate:
	mov		ecx,0x12345678
	mov		eax,esi

	shr		eax,CYCLE_SHIFT
	movsx	edx,word [ecx]

	add		edx,eax
	mov		[ecx],dx

	sbb		edx,edx
_ARMEX_1PerCycleTimerUpdate_End:

_ARMEX_1PerNCycleTimerUpdate:
	mov		ecx,0x12345678
	mov		ebx,esi

	shr		ebx,CYCLE_SHIFT
_ARMEX_1PerNCycleTimerUpdate_LowData:
	mov		edx,[0x12345678]

_ARMEX_1PerNCycleTimerUpdate_Shift:
	shl		ebx,3
	add		edx,ebx

_ARMEX_1PerNCycleTimerUpdate_LowDataCopy:
	mov		[0x12345678],edx

	movsx	edx,word [ecx]

	adc		edx,0

	mov		[ecx],dx

	sbb		edx,edx
_ARMEX_1PerNCycleTimerUpdate_End:

_ARMEX_CascadeTimerUpdate:
	mov		ecx,0x12345678

	add		edx,1

	movsx	edx,word [ecx]

	adc		edx,0

	mov		[ecx],dx

	sbb		edx,edx
_ARMEX_CascadeTimerUpdate_End:

_ARMEX_TimerIRQCheck:
	mov		ecx,edx

_ARMEX_TimerIRQCheck_Mask:
	and		ecx,0x12345678

	or		ecx,[_g_pendingTimerInterrupts]

	mov		[_g_pendingTimerInterrupts],ecx

	mov		ecx,edx

	and		ecx,EXC_TIMER

	or		ebp,ecx
_ARMEX_TimerIRQCheck_End:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  When we do a BX instruction, we have to account for the cycle time of the
; target memory.  I think this is what has been an issue all along.  So let's
; read in the cycle time here.
_ARMEX_GetBranchMemTime:
	mov		edx,[0x12345678]

	shr		edx,24

	and		edx,0xf
_ARMEX_GetBranchMemTime_WaitStates:
	push	dword [edx * 4 + 0x12345678]	; We'll use this later!
_ARMEX_GetBranchMemTime_End:


s_multiplyCycleTimes:
	dd		(4 * CYCLES_I) << 20
	dd		(3 * CYCLES_I) << 20
	dd		(2 * CYCLES_I) << 20
	dd		(2 * CYCLES_I) << 20
	dd		(1 * CYCLES_I) << 20
	dd		(1 * CYCLES_I) << 20
	dd		(1 * CYCLES_I) << 20
	dd		(1 * CYCLES_I) << 20

[SECTION .bss USE32]

s_dummy:
	resd	1
s_scratch1:
	resd	1
s_cycles:
	resd	1
