/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	All of our breakpoint support will go here.  HEREHEREHERE we need to put
in a safeguard for overlapping breakpoints.

****************************************************************************/

#ifndef BREAKPT_H
	#define BREAKPT_H

	enum {
		BP_READ					= 0x01,
		BP_WRITE				= 0x02,
		BP_EXEC					= 0x04,
	};

	enum {
		BP_INTERNAL,
		BP_USER,
	};

	class Breakpoint {
		public:
			u32 base;
			u32 range;
			u8 options;
			u32 curCount;
			u32 countdown;

			Bool operator ==(const Breakpoint & b) const;
	};

	extern void BreakpointSetAllInternal(void);
	extern void BreakpointSet(u32 base, u32 range, u32 countdown, u8 t, u8 op);
	extern void BreakpointReset(MType index, u32 base, u32 range, u32 countdown, u8 t);
	extern void BreakpointClearUser(MType m);
	extern void BreakpointCheck(u32 ip, u32 address, u32 & exceptions);
	extern Bool BreakpointCode(u32 address);
	extern MType BreakpointIsActive(u32 address, u8 flags);
	extern void BreakpointToggle(u32 address);

	extern List < Breakpoint > g_userBreakpoints;

	#include "breakpt.ipp"

#endif
