/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	This handles the DMA chip.

****************************************************************************/

#ifndef DMA_H
	#define DMA_H

	class DMA {
		public:
			DMA(void);
			void SetParent(GBA * parent);
			Bool Tick(u8 condition);
			void TickBackward(void);
			Bool Busy(void);
		protected:
		private:
			u32 m_src[4];
			u32 m_dest[4];
			u32 m_count[4];
			u32 m_incs[4];
			u32 m_incd[4];
			u32 m_size[4];
			u8 m_mode[4];
			Bool m_repeat[4];
	};

	#define DMA0_SOURCE		0x40000b0
	#define DMA0_DEST		0x40000b4
	#define DMA0_CONTROL	0x40000b8
	#define DMA1_SOURCE		0x40000bc
	#define DMA1_DEST		0x40000c0
	#define DMA1_CONTROL	0x40000c4
	#define DMA2_SOURCE		0x40000c8
	#define DMA2_DEST		0x40000cc
	#define DMA2_CONTROL	0x40000d0
	#define DMA3_SOURCE		0x40000d4
	#define DMA3_DEST		0x40000d8
	#define DMA3_CONTROL	0x40000dc

	#define DMA_ENABLE		0x80000000
	#define DMA_IE			0x40000000
	#define DMA_START_IMM	0x00000000
	#define DMA_START_VBL	0x10000000
	#define DMA_START_HBL	0x20000000
	#define DMA_XFER32		0x04000000
	#define DMA_REPEAT_ON	0x02000000
	#define DMA_START_MASK	0x30000000

	#include "dma.ipp"

#endif
