/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	The actual GBA device, with all of its constituent parts.

****************************************************************************/

#ifndef GBADVC_H
	#define GBADVC_H

	class GBA {
		public:
			GBA(void);
			void Load(const FString & filename);
			void GetSymbol(FString & dest, u32 address);
			u32 GetAddress(const FString symbol);	// Opposite of above.
			ARM & GetCPU(void);
			MemoryDispatcher & GetMemory(void);
			VideoProcessor & GetVideo(void);
			DMA & GetDMA(void);
			void Tick(void);
			void TickBackward(void);
			void Reset(void);

			// Number of ticks since reset.
			u32 GetTicks(void);

			// Not in the virtual sense, but when we're actually exiting
			// AGD.
			void ShutDown(void);
		protected:
		private:
			ARM m_processor;
			MemoryDispatcher m_systemMemory;
			VideoProcessor m_video;
			DMA m_dma;
	};

	extern "C" {
		extern GBA g_gba;
	};
	extern u32 g_gbaTicks;

	#include "gbadvc.ipp"

#endif
