/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	This contains much of the state history stuff.

****************************************************************************/

#ifndef HISTORY_H
	#define HISTORY_H

	#define HISTORY_BUFFER_SIZE			65536
	enum {
		HISTORY_FORWARD,
		HISTORY_BACKWARD,
	};
	enum {
		HISTORY_TIMESTAMP = 0,		// How many cycles this op consumes.
		HISTORY_READ,				// A data read was done here.
		HISTORY_WRITE,				// A data write was done here.
		HISTORY_DMA,				// DMA did this transfer.
		HISTORY_TERMINAL,			// There is no history at this point.
	};

	extern void HistoryInitialize(void);
	extern Bool HistoryExists(void);
	extern Bool HistoryGetPrior(u32 & a, u32 & v);
	extern Bool HistoryGetNext(u32 & a, u32 & v);
	extern void HistorySetOrientation(u8 orientation);
	extern u8 HistoryGetOrientation(void);
	extern void HistorySave(U32 * location);
	extern void HistoryFlush(void);

	#include "history.ipp"

#endif
