/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	We make the registration detection logic inline so it can't be easily
hooked.

	HEREHEREHERE we're clearly beta, so no registration yet - but we'll start
putting in the hooks.

****************************************************************************/

#if defined(RELEASE_BUILD) || 1
	inline u8 RegistrationGetLevel(void) {
		return 1;
	}
#else
	#define KEY_PORTION_LENGTH					1
	
	/////////////////////////////////////////////////////////////////////////////
	//  HEREHEREHERE for now.
	inline Bool CheckForHacking(void) {
		return FALSE;
	}
	
	/////////////////////////////////////////////////////////////////////////////
	//  HEREHEREHERE for now.
	inline u8 AssessRegistrationLevel(const FString & key) {
		Warn("Registration key:\n");
		key.DebugOut();
		return 1;
	}
	
	/////////////////////////////////////////////////////////////////////////////
	//  Determine the level of registration.
	inline u8 RegistrationGetLevel(void) {
		u8 numSuccesses = 0;
		FString key;
		HKEY hreg;
		char buf[256];
		LONG dummy;
		Array < U8 > data;
		MType m;
		LONG l;
	
		// Step one:  check if we have the necessary registry entries.
		if (l=RegOpenKey(HKEY_CURRENT_USER,
					   "Software\\ElationWare\\AGD\\License",
					   &hreg) == ERROR_SUCCESS) {
			dummy = 256;
			if (RegQueryValue(hreg, NULL, buf, &dummy) == ERROR_SUCCESS) {
				--dummy;
				if (dummy == KEY_PORTION_LENGTH) {
					key += buf;
					++numSuccesses;
				}
			}
			RegCloseKey(hreg);
		}
	
		// Retrieve the second part of the key.
		if (RegOpenKey(HKEY_LOCAL_MACHINE,
					   "Software\\ElationWare\\AGD\\License",
					   &hreg) == ERROR_SUCCESS) {
			dummy = 256;
			if (RegQueryValue(hreg, NULL, buf, &dummy) == ERROR_SUCCESS) {
				--dummy;
				if (dummy == KEY_PORTION_LENGTH) {
					key += buf;
					++numSuccesses;
				}
			}
			RegCloseKey(hreg);
		}
	
		// We get the next part of the key from a public file in the windows
		// directory.
		if (GetWindowsDirectory(buf, 256)) {
			DirChange(buf);
			data = DirLoadFile("agd.key");
			if (data.Count() == KEY_PORTION_LENGTH) {
				for (m=0; m<KEY_PORTION_LENGTH; ++m) {
					buf[m] = (char)data[m];
				}
				buf[m] = '\0';
				key += buf;
				++numSuccesses;
			}
		}
	
		// Now, we get the fourth part of the key from a hidden file.  We don't
		// actually check to see if the file is hidden, though; we will afford
		// him that much slack :)
		DirChange(DirGetAppPath());
		data = DirLoadFile("agd.key");
		if (data.Count() == KEY_PORTION_LENGTH) {
			for (m=0; m<KEY_PORTION_LENGTH; ++m) {
				buf[m] = (char)data[m];
			}
			buf[m] = '\0';
			key += buf;
			++numSuccesses;
		}
	
		// We have to have success in all areas.
		if ((numSuccesses == 4) && !CheckForHacking()) {
			return AssessRegistrationLevel(key);
		} else if (numSuccesses) {
			// If we have some successes, it indicates to us that the user may
			// have tried to hack his license.  Let's make a scarlet letter.
		}
		return 0;
	}
#endif
