/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	The implementation of the status bar.

****************************************************************************/

#include "gba.h"

extern char * g_appTitle;
FString g_lastLoadedRom="No ROM loaded";
static TString s_clockTicks("Cycles - ");

/////////////////////////////////////////////////////////////////////////////
//  Update the status bar.
void StatusUpdate(void) {
	u16 x;
	FString title;

	title = (FString)g_appTitle;
	x = g_monitor.GetWidth() - title.Length() * TextGetFontWidth(g_font);
	TextWrite(g_monitor,
			  g_font,
			  x,
			  g_monitor.GetHeight() - TextGetFontHeight(g_font),
			  g_colors[TEXT],
			  title);
	title = s_clockTicks;
	ConvertFromHex(title, g_gbaTicks, 8);
	x -= (title.Length() + 2) * TextGetFontWidth(g_font);
	TextWrite(g_monitor,
			  g_font,
			  x,
			  g_monitor.GetHeight() - TextGetFontHeight(g_font),
			  g_colors[TEXT],
			  title);
	TextWrite(g_monitor,
			  g_font,
			  0,
			  g_monitor.GetHeight() - TextGetFontHeight(g_font),
			  g_colors[TEXT],
			  g_lastLoadedRom);
}
