/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	Inlines for the video processor.

****************************************************************************/

/////////////////////////////////////////////////////////////////////////////
//  Construct a video processor.  We seem to be getting some strange values
// for some of our members, so I'm taking this step.
inline VideoProcessor::VideoProcessor(void) {
	m_scanline = 0;
	m_target = TARGET_WINDOW;
}

/////////////////////////////////////////////////////////////////////////////
//  For now, we just flatly state that we are on, in the future we have to
// look at one of the memory mapped registers.
inline Bool VideoProcessor::IsOn(void) {
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
//  Retrieve the current video mode.
inline u8 VideoProcessor::GetMode(void) {
	return m_vidreg[LCDC] & 0x7;
}

/////////////////////////////////////////////////////////////////////////////
//  What rendering period am I presently in?
inline u8 VideoProcessor::GetPeriod(void) {
	if (m_nextEvent == E_HTOTAL) {
		if (m_scanline < 160) {
			return V_HBLANK;
		} else {
			return V_VBLANK;
		}
	} else {
		return V_RENDERING;
	}
}
