/****************************************************************************

	Written by John Marco Panettiere for John Marco Panettiere.
	Copyright 1998, 1999, 2000 by John Marco Panettiere.
	All rights reserved.

	This will implement the small window.  I'm thinking of putting the
registers, or some other small stuff, in this window.

****************************************************************************/

#ifndef WINDOW3_H
	#define WINDOW3_H

	/////////////////////////////////////////////////////////////////////////
	//	This panel holds the current user screen.
	class AppPanel : public Panel {
		public:
			virtual void SetDims(u16 x, u16 y, u16 w, u16 h);
			virtual void Redraw(void);
			virtual void CursorUp(void);
			virtual void CursorDown(void);
			virtual void PageUp(void);
			virtual void PageDown(void);
			virtual void GenerateContent(void);

			Receptor & GetReceptor(void);
		protected:
		private:
			Bitmap m_bitmap;
	};

	/////////////////////////////////////////////////////////////////////////
	//	We need the RegisterPanel to handle the tabs, among other things.
	class RegisterPanel : public TextPanel {
		public:
			virtual void GenerateContent(void);
			virtual void Goto(u32 line);
		protected:
		private:
			u32 m_oldValues[18];
	};

	/////////////////////////////////////////////////////////////////////////
	//	The DMA panel shows the current status of the DMA registers, and
	// whether a DMA transfer is active or not.
	class DMAPanel : public TextPanel {
		public:
			virtual void GenerateContent(void);
		protected:
		private:
	};

	/////////////////////////////////////////////////////////////////////////
	//	I originally intended this to be a sort of peripheral monitor (with
	// sound & video & what-not), but I may put other small datasets here,
	// including the register panel.
	class AppWindow : public Window {
		public:
			enum {
				TAB_APP,
				TAB_REGISTERS,
				TAB_DMA,
			};
			AppWindow(void);
			virtual void SetTab(u8 tab);
			void SingleStep(void);
			void Goto(u32 u);
			void GenerateContent(u8 panel);

			Receptor & GetAppReceptor(void);
		protected:
		private:
			AppPanel m_app;
			RegisterPanel m_registers;
			DMAPanel m_dma;
	};

	#include "window3.ipp"

	extern Sticky < u8 > g_registerFormat;
	extern AppWindow * g_appWindow;

#endif
